Index: cpukit/libdl/rtl-elf.h
===================================================================
--- cpukit/libdl/rtl-elf.h	(revision be50969881b97180bf4fc1e2975efd41169e08bb)
+++ cpukit/libdl/rtl-elf.h	(revision b36c52097f52012f9a52dff6fc8393d63805158b)
@@ -51,4 +51,15 @@
  ** Imported NetBSD ELF Specifics End.
  **/
+
+/**
+ * ELF Relocation status codes.
+ */
+typedef enum rtems_rtl_elf_rel_status
+{
+  rtems_rtl_elf_rel_no_error,    /**< There is no error processing the record. */
+  rtems_rtl_elf_rel_failure,     /**< There was a failure processing the record. */
+  rtems_rtl_elf_rel_tramp_cache, /**< The reloc record may need a trampoliine. */
+  rtems_rtl_elf_rel_tramp_add    /**< Add a trampoliine. */
+} rtems_rtl_elf_rel_status;
 
 /**
@@ -144,18 +155,17 @@
  *
  * @param obj The object file being relocated.
- * @param rel The ELF relocation record.
- * @param sect The section of the object file the relocation is for.
- * @param symname The symbol's name.
- * @param syminfo The ELF symbol info field.
- * @param symvalue If a symbol is referenced, this is the symbols value.
- * @retval bool The relocation is valid.
- * @retval bool The relocation is not valid.
- */
-bool rtems_rtl_elf_relocate_rel_tramp (rtems_rtl_obj*            obj,
-                                       const Elf_Rel*            rel,
-                                       const rtems_rtl_obj_sect* sect,
-                                       const char*               symname,
-                                       const Elf_Byte            syminfo,
-                                       const Elf_Word            symvalue);
+ * @param rela The ELF relocation record.
+ * @param sect The section of the object file the relocation is for.
+ * @param symname The symbol's name.
+ * @param syminfo The ELF symbol info field.
+ * @param symvalue If a symbol is referenced, this is the symbols value.
+ * @retval rtems_rtl_elf_rel_status The result of the trampoline parsing.
+ */
+rtems_rtl_elf_rel_status rtems_rtl_elf_relocate_rel_tramp (rtems_rtl_obj*            obj,
+                                                           const Elf_Rel*            rel,
+                                                           const rtems_rtl_obj_sect* sect,
+                                                           const char*               symname,
+                                                           const Elf_Byte            syminfo,
+                                                           const Elf_Word            symvalue);
 
 /**
@@ -170,13 +180,12 @@
  * @param syminfo The ELF symbol info field.
  * @param symvalue If a symbol is referenced, this is the symbols value.
- * @retval bool The relocation is valid.
- * @retval bool The relocation is not valid.
- */
-bool rtems_rtl_elf_relocate_rela_tramp (rtems_rtl_obj*            obj,
-                                        const Elf_Rela*           rela,
-                                        const rtems_rtl_obj_sect* sect,
-                                        const char*               symname,
-                                        const Elf_Byte            syminfo,
-                                        const Elf_Word            symvalue);
+ * @retval rtems_rtl_elf_rel_status The result of the trampoline parsing.
+ */
+rtems_rtl_elf_rel_status  rtems_rtl_elf_relocate_rela_tramp (rtems_rtl_obj*            obj,
+                                                             const Elf_Rela*           rela,
+                                                             const rtems_rtl_obj_sect* sect,
+                                                             const char*               symname,
+                                                             const Elf_Byte            syminfo,
+                                                             const Elf_Word            symvalue);
 
 /**
@@ -191,13 +200,12 @@
  * @param syminfo The ELF symbol info field.
  * @param symvalue If a symbol is referenced, this is the symbols value.
- * @retval bool The relocation has been applied.
- * @retval bool The relocation could not be applied.
- */
-bool rtems_rtl_elf_relocate_rel (rtems_rtl_obj*            obj,
-                                 const Elf_Rel*            rel,
-                                 const rtems_rtl_obj_sect* sect,
-                                 const char*               symname,
-                                 const Elf_Byte            syminfo,
-                                 const Elf_Word            symvalue);
+ * @retval rtems_rtl_elf_rel_status The result of the trampoline parsing.
+ */
+rtems_rtl_elf_rel_status rtems_rtl_elf_relocate_rel (rtems_rtl_obj*            obj,
+                                                     const Elf_Rel*            rel,
+                                                     const rtems_rtl_obj_sect* sect,
+                                                     const char*               symname,
+                                                     const Elf_Byte            syminfo,
+                                                     const Elf_Word            symvalue);
 
 /**
@@ -212,13 +220,12 @@
  * @param syminfo The ELF symbol info field.
  * @param symvalue If a symbol is referenced, this is the symbols value.
- * @retval bool The relocation has been applied.
- * @retval bool The relocation could not be applied.
- */
-bool rtems_rtl_elf_relocate_rela (rtems_rtl_obj*            obj,
-                                  const Elf_Rela*           rela,
-                                  const rtems_rtl_obj_sect* sect,
-                                  const char*               symname,
-                                  const Elf_Byte            syminfo,
-                                  const Elf_Word            symvalue);
+ * @retval rtems_rtl_elf_rel_status The result of the trampoline parsing.
+ */
+rtems_rtl_elf_rel_status rtems_rtl_elf_relocate_rela (rtems_rtl_obj*            obj,
+                                                      const Elf_Rela*           rela,
+                                                      const rtems_rtl_obj_sect* sect,
+                                                      const char*               symname,
+                                                      const Elf_Byte            syminfo,
+                                                      const Elf_Word            symvalue);
 
 /**
Index: cpukit/libdl/rtl-mdreloc-arm.c
===================================================================
--- cpukit/libdl/rtl-mdreloc-arm.c	(revision be50969881b97180bf4fc1e2975efd41169e08bb)
+++ cpukit/libdl/rtl-mdreloc-arm.c	(revision b36c52097f52012f9a52dff6fc8393d63805158b)
@@ -148,5 +148,5 @@
 }
 
-bool
+rtems_rtl_elf_rel_status
 rtems_rtl_elf_relocate_rela_tramp (rtems_rtl_obj*            obj,
                                    const Elf_Rela*           rela,
@@ -163,8 +163,8 @@
   (void) symvalue;
   rtems_rtl_set_error (EINVAL, "rela type record not supported");
-  return false;
-}
-
-bool
+  return rtems_rtl_elf_rel_failure;
+}
+
+rtems_rtl_elf_rel_status
 rtems_rtl_elf_relocate_rela (rtems_rtl_obj*            obj,
                              const Elf_Rela*           rela,
@@ -181,8 +181,8 @@
   (void) symvalue;
   rtems_rtl_set_error (EINVAL, "rela type record not supported");
-  return false;
-}
-
-static bool
+  return rtems_rtl_elf_rel_failure;
+}
+
+static rtems_rtl_elf_rel_status
 rtems_rtl_elf_reloc_rel (rtems_rtl_obj*            obj,
                          const Elf_Rel*            rel,
@@ -210,20 +210,33 @@
     case R_TYPE(CALL):    /* BL/BLX */
     case R_TYPE(JUMP24):  /* B/BL<cond> */
-      insn = *where;
-
-      if (insn & 0x00800000)
-        addend = insn | 0xff000000;
-      else addend = insn & 0x00ffffff;
-
-      if (isThumb(symvalue)) {
-        if ((insn & 0xfe000000) == 0xfa000000);         /* Already blx */
-        else {
-          if ((insn & 0xff000000) == 0xeb000000) {      /* BL <label> */
-            *where = (insn & 0x00ffffff) | 0xfa000000;  /* BL-->BLX */
-          } else {
-            printf("JUMP24 is not suppored from arm to thumb\n");
-            return false;
+      if (parsing)
+      {
+        addend = 0;
+      }
+      else
+      {
+        insn = *where;
+
+        if (insn & 0x00800000)
+          addend = insn | 0xff000000;
+        else addend = insn & 0x00ffffff;
+
+        if (isThumb(symvalue)) {
+          if ((insn & 0xfe000000) == 0xfa000000);         /* Already blx */
+          else {
+            if ((insn & 0xff000000) == 0xeb000000) {      /* BL <label> */
+              *where = (insn & 0x00ffffff) | 0xfa000000;  /* BL-->BLX */
+            } else {
+              printf("JUMP24 is not suppored from arm to thumb\n");
+              return rtems_rtl_elf_rel_failure;
+            }
           }
         }
+      }
+
+      if (parsing && sect->base == 0) {
+        if (rtems_rtl_trace (RTEMS_RTL_TRACE_RELOC))
+          printf ("rtl: JUMP24/PC24/CALL tramp cache\n");
+        return rtems_rtl_elf_rel_tramp_cache;
       }
 
@@ -236,13 +249,14 @@
 
         if (parsing) {
-          obj->tramp_size += tramp_size;
-          return true;
-        }
-
-        if (!rtems_rtl_obj_has_ramp_space (obj, tramp_size)) {
+          if (rtems_rtl_trace (RTEMS_RTL_TRACE_RELOC))
+            printf ("rtl: JUMP24/PC24/CALL tramp add\n");
+          return rtems_rtl_elf_rel_tramp_add;
+        }
+
+        if (!rtems_rtl_obj_has_tramp_space (obj, tramp_size)) {
           rtems_rtl_set_error (EINVAL,
                                "%s: CALL/JUMP24: overflow: no tramp memory",
                                sect->name);
-          return false;
+          return rtems_rtl_elf_rel_failure;
         }
 
@@ -287,5 +301,5 @@
         if (((Elf_Sword)tmp > 0x7fff) || ((Elf_Sword)tmp < -0x8000)) {
           printf("MOVT_ABS Overflow\n");
-          return false;
+          return rtems_rtl_elf_rel_failure;
         }
       }
@@ -368,11 +382,20 @@
       /* same as THM_PC22; insn b.w */
     case R_TYPE(THM_PC22):
-      upper_insn = *(uint16_t *)where;
-      lower_insn = *((uint16_t *)where + 1);
-      sign = (upper_insn & (1 << 10)) >> 10;
-      i1 = ((lower_insn >> 13) & 1) ^ sign ? 0 : 1;
-      i2 = ((lower_insn >> 11) & 1) ^ sign ? 0 : 1;
-      tmp = (i1 << 23) | (i2 << 22) | ((upper_insn & 0x3ff) << 12) | ((lower_insn & 0x7ff) << 1);
-      addend = (tmp | ((sign ? 0 : 1) << 24)) - (1 << 24);
+      if (parsing)
+      {
+        addend = 0;
+        upper_insn = 0;
+        lower_insn = 0;
+      }
+      else
+      {
+        upper_insn = *(uint16_t *)where;
+        lower_insn = *((uint16_t *)where + 1);
+        sign = (upper_insn & (1 << 10)) >> 10;
+        i1 = ((lower_insn >> 13) & 1) ^ sign ? 0 : 1;
+        i2 = ((lower_insn >> 11) & 1) ^ sign ? 0 : 1;
+        tmp = (i1 << 23) | (i2 << 22) | ((upper_insn & 0x3ff) << 12) | ((lower_insn & 0x7ff) << 1);
+        addend = (tmp | ((sign ? 0 : 1) << 24)) - (1 << 24);
+      }
 
       if (isThumb(symvalue)) ;/*Thumb to Thumb call, nothing to care */
@@ -382,11 +405,17 @@
 #if !ALLOW_UNTESTED_RELOCS
           printf("THM_JUMP24 to arm not supported\n");
-          return false;
+          return rtems_rtl_elf_rel_failure;
 #endif
         }
         else {
           /* THM_CALL bl-->blx */
-          lower_insn &=~(1<<12);
-        }
+          lower_insn &= ~(1<<12);
+        }
+      }
+
+      if (parsing && sect->base == 0) {
+        if (rtems_rtl_trace (RTEMS_RTL_TRACE_RELOC))
+          printf ("rtl: THM_CALL/JUMP24 tramp cache\n");
+        return rtems_rtl_elf_rel_tramp_cache;
       }
 
@@ -395,17 +424,19 @@
 
       if (((Elf_Sword)tmp > 0x7fffff) || ((Elf_Sword)tmp < -0x800000)) {
-          Elf_Word tramp_addr;
-          size_t   tramp_size = get_veneer_size(ELF_R_TYPE(rel->r_info));
+        Elf_Word tramp_addr;
+        size_t   tramp_size = get_veneer_size(ELF_R_TYPE(rel->r_info));
 
         if (parsing) {
-          obj->tramp_size += tramp_size;
-          return true;
-        }
-
-        if (!rtems_rtl_obj_has_ramp_space (obj, tramp_size)) {
+          if (rtems_rtl_trace (RTEMS_RTL_TRACE_RELOC))
+            printf ("rtl: THM_CALL/JUMP24 tramp add: %08x - %p = %i\n",
+                    symvalue + addend, where, (Elf_Sword) tmp);
+          return rtems_rtl_elf_rel_tramp_add;
+        }
+
+        if (!rtems_rtl_obj_has_tramp_space (obj, tramp_size)) {
           rtems_rtl_set_error (EINVAL,
                                "%s: THM_CALL/JUMP24: overflow: no tramp memory",
                                sect->name);
-          return false;
+          return rtems_rtl_elf_rel_failure;
         }
 
@@ -439,5 +470,5 @@
       if (!isThumb(symvalue)) {
         printf("THM_JUMP19 to arm not supported\n");
-        return false;
+        return rtems_rtl_elf_rel_failure;
       }
 
@@ -464,6 +495,5 @@
                              "THM_JUMP19 relocations",
                              sect->name, (uint32_t) ELF_R_TYPE(rel->r_info));
-        return true;
-        return false;
+        return rtems_rtl_elf_rel_failure;
       }
 
@@ -512,11 +542,11 @@
                            "in non-PLT relocations",
                            sect->name, (uint32_t) ELF_R_TYPE(rel->r_info));
-      return false;
+      return rtems_rtl_elf_rel_failure;
   }
 
-  return true;
-}
-
-bool
+  return rtems_rtl_elf_rel_no_error;
+}
+
+rtems_rtl_elf_rel_status
 rtems_rtl_elf_relocate_rel_tramp (rtems_rtl_obj*            obj,
                                   const Elf_Rel*            rel,
@@ -535,5 +565,5 @@
 }
 
-bool
+rtems_rtl_elf_rel_status
 rtems_rtl_elf_relocate_rel (rtems_rtl_obj*            obj,
                             const Elf_Rel*            rel,
Index: cpukit/libdl/rtl-mdreloc-bfin.c
===================================================================
--- cpukit/libdl/rtl-mdreloc-bfin.c	(revision be50969881b97180bf4fc1e2975efd41169e08bb)
+++ cpukit/libdl/rtl-mdreloc-bfin.c	(revision b36c52097f52012f9a52dff6fc8393d63805158b)
@@ -74,5 +74,5 @@
 }
 
-bool
+rtems_rtl_elf_rel_status
 rtems_rtl_elf_relocate_rela_tramp (rtems_rtl_obj*            obj,
                                    const Elf_Rela*           rela,
@@ -88,8 +88,8 @@
   (void) syminfo;
   (void) symvalue;
-  return true;
-}
-
-bool
+  return rtems_rtl_elf_rel_no_error;
+}
+
+rtems_rtl_elf_rel_status
 rtems_rtl_elf_relocate_rela (rtems_rtl_obj*            obj,
                              const Elf_Rela*           rela,
@@ -137,5 +137,5 @@
       if ((tmp & 0xff000000) && (~tmp & 0xff800000)) {
         printf("PCREL24/PCREL24_JU Overflow\n");
-        return false;
+        return rtems_rtl_elf_rel_failure;
       }
 
@@ -153,5 +153,5 @@
       if ((tmp & 0xfffff000) && (~tmp & 0xfffff800)) {
         printf("PCREL12_JUMP_S Overflow\n");
-        return false;
+        return rtems_rtl_elf_rel_failure;
       }
 
@@ -162,13 +162,13 @@
     default:
       printf("Unspported rela type\n");
-      return false;
+      return rtems_rtl_elf_rel_failure;
   }
 
   memcpy((void*)where, &tmp, size);
 
-  return true;
-}
-
-bool
+  return rtems_rtl_elf_rel_no_error;
+}
+
+rtems_rtl_elf_rel_status
 rtems_rtl_elf_relocate_rel_tramp (rtems_rtl_obj*            obj,
                                   const Elf_Rel*            rel,
@@ -185,8 +185,8 @@
   (void) symvalue;
   rtems_rtl_set_error (EINVAL, "rel type record not supported");
-  return false;
-}
-
-bool
+  return rtems_rtl_elf_rel_failure;
+}
+
+rtems_rtl_elf_rel_status
 rtems_rtl_elf_relocate_rel (rtems_rtl_obj*            obj,
                             const Elf_Rel*            rel,
@@ -203,5 +203,5 @@
   (void) symvalue;
   rtems_rtl_set_error (EINVAL, "rel type record not supported");
-  return false;
+  return rtems_rtl_elf_rel_failure;
 }
 
Index: cpukit/libdl/rtl-mdreloc-h8300.c
===================================================================
--- cpukit/libdl/rtl-mdreloc-h8300.c	(revision be50969881b97180bf4fc1e2975efd41169e08bb)
+++ cpukit/libdl/rtl-mdreloc-h8300.c	(revision b36c52097f52012f9a52dff6fc8393d63805158b)
@@ -67,5 +67,5 @@
 }
 
-bool
+rtems_rtl_elf_rel_status
 rtems_rtl_elf_relocate_rela_tramp (rtems_rtl_obj*            obj,
                                    const Elf_Rela*           rela,
@@ -81,8 +81,8 @@
   (void) syminfo;
   (void) symvalue;
-  return true;
-}
-
-bool
+  return rtems_rtl_elf_rel_no_error;
+}
+
+rtems_rtl_elf_rel_status
 rtems_rtl_elf_relocate_rela (rtems_rtl_obj*            obj,
                              const Elf_Rela*           rela,
@@ -131,5 +131,5 @@
       if (((Elf32_Sword)tmp > 0x7f) || ((Elf32_Sword)tmp < -(Elf32_Sword)0x80)){
         printf("PCREL8 overflow\n");
-          return false;
+          return rtems_rtl_elf_rel_failure;
       } else {
         *(uint8_t *)where = tmp;
@@ -142,5 +142,5 @@
       if (((Elf32_Sword)tmp > 0x7fff) || ((Elf32_Sword)tmp < -(Elf32_Sword)0x8000)){
         printf("PCREL16 overflow\n");
-       return false;
+       return rtems_rtl_elf_rel_failure;
       } else {
        *(uint16_t *)where = tmp;
@@ -151,10 +151,10 @@
       rtems_rtl_set_error (EINVAL, "rela type record not supported");
       printf("Unsupported reloc types\n");
-      return false;
+      return rtems_rtl_elf_rel_failure;
   }
-  return true;
-}
-
-bool
+  return rtems_rtl_elf_rel_no_error;
+}
+
+rtems_rtl_elf_rel_status
 rtems_rtl_elf_relocate_rel_tramp (rtems_rtl_obj*           obj,
                                   const Elf_Rel*            rel,
@@ -171,8 +171,8 @@
   (void) symvalue;
   rtems_rtl_set_error (EINVAL, "rel type record not supported");
-  return false;
-}
-
-bool
+  return rtems_rtl_elf_rel_failure;
+}
+
+rtems_rtl_elf_rel_status
 rtems_rtl_elf_relocate_rel (rtems_rtl_obj*            obj,
                             const Elf_Rel*            rel,
@@ -189,5 +189,5 @@
   (void) symvalue;
   rtems_rtl_set_error (EINVAL, "rel type record not supported");
-  return false;
+  return rtems_rtl_elf_rel_failure;
 }
 
Index: cpukit/libdl/rtl-mdreloc-i386.c
===================================================================
--- cpukit/libdl/rtl-mdreloc-i386.c	(revision be50969881b97180bf4fc1e2975efd41169e08bb)
+++ cpukit/libdl/rtl-mdreloc-i386.c	(revision b36c52097f52012f9a52dff6fc8393d63805158b)
@@ -74,5 +74,5 @@
 }
 
-bool
+rtems_rtl_elf_rel_status
 rtems_rtl_elf_relocate_rela_tramp (rtems_rtl_obj*            obj,
                                    const Elf_Rela*           rela,
@@ -89,8 +89,8 @@
   (void) symvalue;
   rtems_rtl_set_error (EINVAL, "rela type record not supported");
-  return false;
-}
-
-bool
+  return rtems_rtl_elf_rel_failure;
+}
+
+rtems_rtl_elf_rel_status
 rtems_rtl_elf_relocate_rela (rtems_rtl_obj*            obj,
                              const Elf_Rela*           rel,
@@ -107,8 +107,8 @@
   (void) symvalue;
   rtems_rtl_set_error (EINVAL, "rela type record not supported");
-  return false;
-}
-
-bool
+  return rtems_rtl_elf_rel_failure;
+}
+
+rtems_rtl_elf_rel_status
 rtems_rtl_elf_relocate_rel_tramp (rtems_rtl_obj*            obj,
                                   const Elf_Rel*            rel,
@@ -124,8 +124,8 @@
   (void) syminfo;
   (void) symvalue;
-  return true;
-}
-
-bool
+  return rtems_rtl_elf_rel_no_error;
+}
+
+rtems_rtl_elf_rel_status
 rtems_rtl_elf_relocate_rel (rtems_rtl_obj*            obj,
                             const Elf_Rel*            rel,
@@ -189,8 +189,8 @@
                            "in non-PLT relocations",
                            sect->name, (uint32_t) ELF_R_TYPE(rel->r_info));
-      return false;
+      return rtems_rtl_elf_rel_failure;
   }
 
-  return true;
+  return rtems_rtl_elf_rel_no_error;
 }
 
Index: cpukit/libdl/rtl-mdreloc-lm32.c
===================================================================
--- cpukit/libdl/rtl-mdreloc-lm32.c	(revision be50969881b97180bf4fc1e2975efd41169e08bb)
+++ cpukit/libdl/rtl-mdreloc-lm32.c	(revision b36c52097f52012f9a52dff6fc8393d63805158b)
@@ -67,5 +67,5 @@
 }
 
-bool
+rtems_rtl_elf_rel_status
 rtems_rtl_elf_relocate_rela_tramp (rtems_rtl_obj*            obj,
                                    const Elf_Rela*           rela,
@@ -81,8 +81,8 @@
   (void) syminfo;
   (void) symvalue;
-  return true;
-}
-
-bool
+  return rtems_rtl_elf_rel_no_error;
+}
+
+rtems_rtl_elf_rel_status
 rtems_rtl_elf_relocate_rela (rtems_rtl_obj*            obj,
                              const Elf_Rela*           rela,
@@ -152,5 +152,5 @@
       if (((Elf32_Sword)tmp > 0x7fff) || ((Elf32_Sword)tmp < -0x8000)){
         printf("BRANCH Overflow\n");
-        return false;
+        return rtems_rtl_elf_rel_failure;
       }
 
@@ -165,5 +165,5 @@
       rtems_rtl_set_error (EINVAL, "rela type record not supported");
       printf("Unsupported reloc types\n");
-      return false;
+      return rtems_rtl_elf_rel_failure;
   }
 
@@ -172,8 +172,9 @@
       printf("relocated address 0x%08lx\n", (Elf_Addr)where);
   }
-  return true;
-}
-
-bool
+
+  return rtems_rtl_elf_rel_no_error;
+}
+
+rtems_rtl_elf_rel_status
 rtems_rtl_elf_relocate_rel_tramp (rtems_rtl_obj*            obj,
                                   const Elf_Rel*            rel,
@@ -190,8 +191,8 @@
   (void) symvalue;
   rtems_rtl_set_error (EINVAL, "rel type record not supported");
-  return false;
-}
-
-bool
+  return rtems_rtl_elf_rel_failure;
+}
+
+rtems_rtl_elf_rel_status
 rtems_rtl_elf_relocate_rel (rtems_rtl_obj*            obj,
                             const Elf_Rel*            rel,
@@ -208,5 +209,5 @@
   (void) symvalue;
   rtems_rtl_set_error (EINVAL, "rela type record not supported");
-  return false;
+  return rtems_rtl_elf_rel_failure;
 }
 
Index: cpukit/libdl/rtl-mdreloc-m68k.c
===================================================================
--- cpukit/libdl/rtl-mdreloc-m68k.c	(revision be50969881b97180bf4fc1e2975efd41169e08bb)
+++ cpukit/libdl/rtl-mdreloc-m68k.c	(revision b36c52097f52012f9a52dff6fc8393d63805158b)
@@ -87,5 +87,5 @@
 }
 
-bool
+rtems_rtl_elf_rel_status
 rtems_rtl_elf_relocate_rela_tramp (rtems_rtl_obj*            obj,
                                    const Elf_Rela*           rela,
@@ -101,8 +101,8 @@
   (void) syminfo;
   (void) symvalue;
-  return true;
-}
-
-bool
+  return rtems_rtl_elf_rel_no_error;
+}
+
+rtems_rtl_elf_rel_status
 rtems_rtl_elf_relocate_rela (rtems_rtl_obj*            obj,
                              const Elf_Rela*           rela,
@@ -119,89 +119,89 @@
 
   switch (ELF_R_TYPE(rela->r_info)) {
-		case R_TYPE(NONE):
-			break;
-
-    case R_TYPE(PC8):
-      tmp = symvalue + rela->r_addend - (Elf_Addr)where;
-      if (overflow_8_check(tmp))
-        return false;
-
-      *(uint8_t *)where = tmp;
-
-      if (rtems_rtl_trace (RTEMS_RTL_TRACE_RELOC))
-        printf ("rtl: reloc R_TYPE_8/PC8 in %s --> %p (%p) in %s\n",
-                sect->name, (void*) (symvalue + rela->r_addend),
-                (void *)*where, rtems_rtl_obj_oname (obj));
-      break;
-
-    case R_TYPE(PC16):
-      tmp = symvalue + rela->r_addend - (Elf_Addr)where;
-      if (overflow_16_check(tmp))
-        return false;
-
-      *(uint16_t*)where = tmp;
-
-      if (rtems_rtl_trace (RTEMS_RTL_TRACE_RELOC))
-        printf ("rtl: reloc R_TYPE_16/PC16 in %s --> %p (%p) in %s\n",
-                sect->name, (void*) (symvalue + rela->r_addend),
-                (void *)*where, rtems_rtl_obj_oname (obj));
-      break;
-		case R_TYPE(PC32):
-      target = (Elf_Addr) symvalue + rela->r_addend;
-      *where += target - (Elf_Addr)where;
-
-      if (rtems_rtl_trace (RTEMS_RTL_TRACE_RELOC))
-        printf ("rtl: reloc PC32 in %s --> %p (%p) in %s\n",
-                sect->name, (void*) (symvalue + rela->r_addend),
-                (void *)*where, rtems_rtl_obj_oname (obj));
-      break;
-
-		case R_TYPE(GOT32):
-		case R_TYPE(32):
-		case R_TYPE(GLOB_DAT):
-      target = (Elf_Addr) symvalue + rela->r_addend;
-
-			if (*where != target)
-				*where = target;
-
-      if (rtems_rtl_trace (RTEMS_RTL_TRACE_RELOC))
-        printf ("rtl: reloc 32/GLOB_DAT in %s --> %p in %s\n",
-                sect->name, (void *)*where,
-                rtems_rtl_obj_oname (obj));
-			break;
-
-		case R_TYPE(RELATIVE):
-			*where += (Elf_Addr) sect->base + rela->r_addend;
-      if (rtems_rtl_trace (RTEMS_RTL_TRACE_RELOC))
-        printf ("rtl: reloc RELATIVE in %s --> %p\n",
-                rtems_rtl_obj_oname (obj), (void *)*where);
-			break;
-
-		case R_TYPE(COPY):
-			/*
-			 * These are deferred until all other relocations have
-			 * been done.  All we do here is make sure that the
-			 * COPY relocation is not in a shared library.  They
-			 * are allowed only in executable files.
-			 */
-      printf ("rtl: reloc COPY (please report)\n");
-			break;
-
-		default:
-      printf ("rtl: reloc unknown: sym = %u, type = %u, offset = %p, "
-              "contents = %p\n",
-              ELF_R_SYM(rela->r_info), (uint32_t) ELF_R_TYPE(rela->r_info),
-              (void *)rela->r_offset, (void *)*where);
-      rtems_rtl_set_error (EINVAL,
-                           "%s: Unsupported relocation type %d "
-                           "in non-PLT relocations",
-                           sect->name, (uint32_t) ELF_R_TYPE(rela->r_info));
-      return false;
+  case R_TYPE(NONE):
+    break;
+
+  case R_TYPE(PC8):
+    tmp = symvalue + rela->r_addend - (Elf_Addr)where;
+    if (overflow_8_check(tmp))
+      return rtems_rtl_elf_rel_failure;
+
+    *(uint8_t *)where = tmp;
+
+    if (rtems_rtl_trace (RTEMS_RTL_TRACE_RELOC))
+      printf ("rtl: reloc R_TYPE_8/PC8 in %s --> %p (%p) in %s\n",
+              sect->name, (void*) (symvalue + rela->r_addend),
+              (void *)*where, rtems_rtl_obj_oname (obj));
+    break;
+
+  case R_TYPE(PC16):
+    tmp = symvalue + rela->r_addend - (Elf_Addr)where;
+    if (overflow_16_check(tmp))
+      return rtems_rtl_elf_rel_failure;
+
+    *(uint16_t*)where = tmp;
+
+    if (rtems_rtl_trace (RTEMS_RTL_TRACE_RELOC))
+      printf ("rtl: reloc R_TYPE_16/PC16 in %s --> %p (%p) in %s\n",
+              sect->name, (void*) (symvalue + rela->r_addend),
+              (void *)*where, rtems_rtl_obj_oname (obj));
+    break;
+  case R_TYPE(PC32):
+    target = (Elf_Addr) symvalue + rela->r_addend;
+    *where += target - (Elf_Addr)where;
+
+    if (rtems_rtl_trace (RTEMS_RTL_TRACE_RELOC))
+      printf ("rtl: reloc PC32 in %s --> %p (%p) in %s\n",
+              sect->name, (void*) (symvalue + rela->r_addend),
+              (void *)*where, rtems_rtl_obj_oname (obj));
+    break;
+
+  case R_TYPE(GOT32):
+  case R_TYPE(32):
+  case R_TYPE(GLOB_DAT):
+    target = (Elf_Addr) symvalue + rela->r_addend;
+
+    if (*where != target)
+      *where = target;
+
+    if (rtems_rtl_trace (RTEMS_RTL_TRACE_RELOC))
+      printf ("rtl: reloc 32/GLOB_DAT in %s --> %p in %s\n",
+              sect->name, (void *)*where,
+              rtems_rtl_obj_oname (obj));
+    break;
+
+  case R_TYPE(RELATIVE):
+    *where += (Elf_Addr) sect->base + rela->r_addend;
+    if (rtems_rtl_trace (RTEMS_RTL_TRACE_RELOC))
+      printf ("rtl: reloc RELATIVE in %s --> %p\n",
+              rtems_rtl_obj_oname (obj), (void *)*where);
+    break;
+
+  case R_TYPE(COPY):
+    /*
+     * These are deferred until all other relocations have
+     * been done.  All we do here is make sure that the
+     * COPY relocation is not in a shared library.  They
+     * are allowed only in executable files.
+     */
+    printf ("rtl: reloc COPY (please report)\n");
+    break;
+
+  default:
+    printf ("rtl: reloc unknown: sym = %u, type = %u, offset = %p, "
+            "contents = %p\n",
+            ELF_R_SYM(rela->r_info), (uint32_t) ELF_R_TYPE(rela->r_info),
+            (void *)rela->r_offset, (void *)*where);
+    rtems_rtl_set_error (EINVAL,
+                         "%s: Unsupported relocation type %d "
+                         "in non-PLT relocations",
+                         sect->name, (uint32_t) ELF_R_TYPE(rela->r_info));
+    return rtems_rtl_elf_rel_failure;
   }
 
-  return true;
-}
-
-bool
+  return rtems_rtl_elf_rel_no_error;
+}
+
+rtems_rtl_elf_rel_status
 rtems_rtl_elf_relocate_rel_tramp (rtems_rtl_obj*            obj,
                                   const Elf_Rel*            rel,
@@ -218,8 +218,8 @@
   (void) symvalue;
   rtems_rtl_set_error (EINVAL, "rel type record not supported");
-  return false;
-}
-
-bool
+  return rtems_rtl_elf_rel_failure;
+}
+
+rtems_rtl_elf_rel_status
 rtems_rtl_elf_relocate_rel (rtems_rtl_obj*            obj,
                             const Elf_Rel*            rel,
@@ -236,5 +236,5 @@
   (void) symvalue;
   rtems_rtl_set_error (EINVAL, "rel type record not supported");
-  return false;
+  return rtems_rtl_elf_rel_failure;
 }
 
Index: cpukit/libdl/rtl-mdreloc-mips.c
===================================================================
--- cpukit/libdl/rtl-mdreloc-mips.c	(revision be50969881b97180bf4fc1e2975efd41169e08bb)
+++ cpukit/libdl/rtl-mdreloc-mips.c	(revision b36c52097f52012f9a52dff6fc8393d63805158b)
@@ -67,5 +67,5 @@
 }
 
-bool
+rtems_rtl_elf_rel_status
 rtems_rtl_elf_relocate_rela_tramp (rtems_rtl_obj*            obj,
                                    const Elf_Rela*           rela,
@@ -82,8 +82,8 @@
   (void) symvalue;
   rtems_rtl_set_error (EINVAL, "rela type record not supported");
-  return false;
-}
-
-bool
+  return rtems_rtl_elf_rel_failure;
+}
+
+rtems_rtl_elf_rel_status
 rtems_rtl_elf_relocate_rela (rtems_rtl_obj*            obj,
                              const Elf_Rela*           rela,
@@ -100,8 +100,8 @@
   (void) symvalue;
   rtems_rtl_set_error (EINVAL, "rela type record not supported");
-  return false;
-}
-
-bool
+  return rtems_rtl_elf_rel_failure;
+}
+
+rtems_rtl_elf_rel_status
 rtems_rtl_elf_relocate_rel_tramp (rtems_rtl_obj*            obj,
                                   const Elf_Rel*            rel,
@@ -117,5 +117,5 @@
   (void) syminfo;
   (void) symvalue;
-  return true;
+  return rtems_rtl_elf_rel_no_error;
 }
 
@@ -128,5 +128,5 @@
  * just consider symtype here.
  */
-bool
+rtems_rtl_elf_rel_status
 rtems_rtl_elf_relocate_rel (rtems_rtl_obj*            obj,
                             const Elf_Rel*            rel,
@@ -163,5 +163,5 @@
       if ((tmp & 0xffff0000) != 0) {
         printf("R_MIPS_16 Overflow\n");
-        return false;
+        return rtems_rtl_elf_rel_failure;
       }
 
@@ -225,5 +225,5 @@
       tmp = symvalue;
       if (tmp == 0)
-        return false;
+        return rtems_rtl_elf_rel_failure;
 
       addend &= 0xffff0000;
@@ -255,5 +255,5 @@
       if (((Elf_Sword)tmp > 0x7fff) || ((Elf_Sword)tmp < -0x8000)) {
         printf("R_MIPS_PC16 Overflow\n");
-        return false;
+        return rtems_rtl_elf_rel_failure;
       }
 
@@ -275,8 +275,8 @@
                            "in non-PLT relocations",
                            sect->name, (uint32_t) ELF_R_TYPE(rel->r_info));
-      return false;
+      return rtems_rtl_elf_rel_failure;
   }
 
-  return true;
+  return rtems_rtl_elf_rel_no_error;
 }
 
